float T1=0;
float T2=0;
float T3=0;
float T4=0;
float T5=0;
float L1=100.00;
float L2=100.00;
float L3=100.00;
float L4=100.00;
const int sensor0 = A0;
const int sensor1 = A1;
const int sensor2 = A2;
const int sensor3 = A3;
const int sensor4 = A4;
const float pi = 3.14159267; 

void sendFloat(float f,unsigned t) {
  byte * b = (byte *) &f;
  Serial.write(t);
  Serial.write(b[0]);
  Serial.write(b[1]);
  Serial.write(b[2]);
  Serial.write(b[3]);
  Serial.write(b[4]);
  Serial.write(b[5]);
  Serial.write(b[6]);
  Serial.write(b[7]);
  Serial.write(b[8]);
  Serial.write(b[9]);
  Serial.write(b[10]);
  Serial.write(b[11]);
  Serial.write(b[12]);
  Serial.write(b[13]);
  Serial.write(b[14]);
  
}
void setup()
{
  Serial.begin(19200);
}

void loop()

{
   //....................................................................
  float sensorValue0 = analogRead(sensor0);
  float sensorValue1 = analogRead(sensor1);
  float sensorValue2 = analogRead(sensor2);
  float sensorValue3 = analogRead(sensor3);
  float sensorValue4 = analogRead(sensor4);

  float derajat_A_akhir;
  float derajat_B_akhir;
  float derajat_C_akhir;
  float derajat_D_akhir;
  float derajat_E_akhir;
//.....................................................................
  float  derajat_A = map(sensorValue0, 0, 1023, 0, 300);
  if (derajat_A <150.00){
      derajat_A_akhir = (derajat_A+210.00);
  }else{
      derajat_A_akhir = derajat_A-150.00;
  }   
  float  derajat_B = map(sensorValue1, 0, 1023, 0, 300);
  if (derajat_B <150.00){
      derajat_B_akhir = derajat_B+210.00;
  }else{
      derajat_B_akhir = derajat_B-150.00;
  }
  float  derajat_C = map(sensorValue2, 0, 1023, 0, 300);
  if (derajat_C <150.00){
      derajat_C_akhir = derajat_C+210.00;
  }else{
      derajat_C_akhir = derajat_C-150.00;
  }
  float  derajat_D = map(sensorValue3, 0, 1023, 0, 300);
  if (derajat_D <150.00){
      derajat_D_akhir = derajat_D+210.00;
  }else{
      derajat_D_akhir = derajat_D-150.00;
  }
  float  derajat_E = map(sensorValue4, 0, 1023, 0, 300);
  if (derajat_E <150.00){
      derajat_E_akhir = derajat_E+210.00;
  }else{
      derajat_E_akhir = derajat_E-150.00;
  }
//.....................................................................
  float T1= derajat_A_akhir*pi/180;
  float T2= derajat_B_akhir*pi/180;
  float T3= derajat_C_akhir*pi/180;
  float T4= derajat_D_akhir*pi/180;
  float T5= derajat_E_akhir*pi/180;
//.....................................................................
      float A[4][4]=
      {
        { cos(T1) , 0        ,sin(T1)   , 0          },
        { sin(T1) , 0        ,-cos(T1)  , 0          },
        { 0       , 1        , 0        , L1         },
        { 0       , 0        , 0        , 1          }
      };
      float B[4][4]=
      {
        { cos(T2) , -sin(T2) , 0        , L2*cos(T2) },
        { sin(T2) , cos(T2)  , 0        , L2*sin(T2) },
        { 0       , 0        , 1        , 0          },
        { 0       , 0        , 0        , 1          }
      };
      float C[4][4]=
      {
        { cos(T3) , -sin(T3) ,0         , L3*cos(T3) },
        { sin(T3) , cos(T3)  ,0         , L3*sin(T3) },
        { 0       , 0        , 1        , 0          },
        { 0       , 0        , 0        , 1          }
      };
      float D[4][4]=
      {
        { 1       , 0        ,0         , 0          },
        { 0       , cos(T4)  ,-sin(T4)  , 0          },
        { 0       , sin(T4)  , cos(T4)  , 0          },
        { 0       , 0        , 0        , 1          }
      };
      float E[4][4]=
      {
        { cos(T5) , -sin(T5) , 0        , L4*cos(T5) },
        { sin(T5) , cos(T5)  , 0        , L4*sin(T5) },
        { 0       , 0        , 1        , 0          },
        { 0       , 0        , 0        , 1          }
      };
//....................................................................................
float F00= (A[0][0]*B[0][0])+(A[0][1]*B[1][0])+(A[0][2]*B[2][0])+(A[0][3]*B[3][0]);
float F01= (A[0][0]*B[0][1])+(A[0][1]*B[1][1])+(A[0][2]*B[2][1])+(A[0][3]*B[3][1]);
float F02= (A[0][0]*B[0][2])+(A[0][1]*B[1][2])+(A[0][2]*B[2][2])+(A[0][3]*B[3][2]);
float F03= (A[0][0]*B[0][3])+(A[0][1]*B[1][3])+(A[0][2]*B[2][3])+(A[0][3]*B[3][3]);
   
float F10= (A[1][0]*B[0][0])+(A[1][1]*B[1][0])+(A[1][2]*B[2][0])+(A[1][3]*B[3][0]);
float F11= (A[1][0]*B[0][1])+(A[1][1]*B[1][1])+(A[1][2]*B[2][1])+(A[1][3]*B[3][1]);
float F12= (A[1][0]*B[0][2])+(A[1][1]*B[1][2])+(A[1][2]*B[2][2])+(A[1][3]*B[3][2]);
float F13= (A[1][0]*B[0][3])+(A[1][1]*B[1][3])+(A[1][2]*B[2][3])+(A[1][3]*B[3][3]);

float F20= (A[2][0]*B[0][0])+(A[2][1]*B[1][0])+(A[2][2]*B[2][0])+(A[2][3]*B[3][0]);
float F21= (A[2][0]*B[0][1])+(A[2][1]*B[1][1])+(A[2][2]*B[2][1])+(A[2][3]*B[3][1]);
float F22= (A[2][0]*B[0][2])+(A[2][1]*B[1][2])+(A[2][2]*B[2][2])+(A[2][3]*B[3][2]);
float F23= (A[2][0]*B[0][3])+(A[2][1]*B[1][3])+(A[2][2]*B[2][3])+(A[2][3]*B[3][3]);

float F30= (A[3][0]*B[0][0])+(A[3][1]*B[1][0])+(A[3][2]*B[2][0])+(A[3][3]*B[3][0]);
float F31= (A[3][0]*B[0][1])+(A[3][1]*B[1][1])+(A[3][2]*B[2][1])+(A[3][3]*B[3][1]);
float F32= (A[3][0]*B[0][2])+(A[3][1]*B[1][2])+(A[3][2]*B[2][2])+(A[3][3]*B[3][2]);
float F33= (A[3][0]*B[0][3])+(A[3][1]*B[1][3])+(A[3][2]*B[2][3])+(A[3][3]*B[3][3]);
//....................................................................................
float G00= (C[0][0]*D[0][0])+(C[0][1]*D[1][0])+(C[0][2]*D[2][0])+(C[0][3]*D[3][0]);
float G01= (C[0][0]*D[0][1])+(C[0][1]*D[1][1])+(C[0][2]*D[2][1])+(C[0][3]*D[3][1]);
float G02= (C[0][0]*D[0][2])+(C[0][1]*D[1][2])+(C[0][2]*D[2][2])+(C[0][3]*D[3][2]);
float G03= (C[0][0]*D[0][3])+(C[0][1]*D[1][3])+(C[0][2]*D[2][3])+(C[0][3]*D[3][3]);

float G10= (C[1][0]*D[0][0])+(C[1][1]*D[1][0])+(C[1][2]*D[2][0])+(C[1][3]*D[3][0]);
float G11= (C[1][0]*D[0][1])+(C[1][1]*D[1][1])+(C[1][2]*D[2][1])+(C[1][3]*D[3][1]);
float G12= (C[1][0]*D[0][2])+(C[1][1]*D[1][2])+(C[1][2]*D[2][2])+(C[1][3]*D[3][2]);
float G13= (C[1][0]*D[0][3])+(C[1][1]*D[1][3])+(C[1][2]*D[2][3])+(C[1][3]*D[3][3]);

float G20= (C[2][0]*D[0][0])+(C[2][1]*D[1][0])+(C[2][2]*D[2][0])+(C[2][3]*D[3][0]);
float G21= (C[2][0]*D[0][1])+(C[2][1]*D[1][1])+(C[2][2]*D[2][1])+(C[2][3]*D[3][1]);
float G22= (C[2][0]*D[0][2])+(C[2][1]*D[1][2])+(C[2][2]*D[2][2])+(C[2][3]*D[3][2]);
float G23= (C[2][0]*D[0][3])+(C[2][1]*D[1][3])+(C[2][2]*D[2][3])+(C[2][3]*D[3][3]);

float G30= (C[3][0]*D[0][0])+(C[3][1]*D[1][0])+(C[3][2]*D[2][0])+(C[3][3]*D[3][0]);
float G31= (C[3][0]*D[0][1])+(C[3][1]*D[1][1])+(C[3][2]*D[2][1])+(C[3][3]*D[3][1]);
float G32= (C[3][0]*D[0][2])+(C[3][1]*D[1][2])+(C[3][2]*D[2][2])+(C[3][3]*D[3][2]);
float G33= (C[3][0]*D[0][3])+(C[3][1]*D[1][3])+(C[3][2]*D[2][3])+(C[3][3]*D[3][3]);
//....................................................................................
float H00= (F00*G00)+(F01*G10)+(F02*G20)+(F03*G30);
float H01= (F00*G01)+(F01*G11)+(F02*G21)+(F03*G31);
float H02= (F00*G02)+(F01*G12)+(F02*G22)+(F03*G32);
float H03= (F00*G03)+(F01*G13)+(F02*G23)+(F03*G33);

float H10= (F10*G00)+(F11*G10)+(F12*G20)+(F13*G30);
float H11= (F10*G01)+(F11*G11)+(F12*G21)+(F13*G31);
float H12= (F10*G02)+(F11*G12)+(F12*G22)+(F13*G32);
float H13= (F10*G03)+(F11*G13)+(F12*G23)+(F13*G33);

float H20= (F20*G00)+(F21*G10)+(F22*G20)+(F23*G30);
float H21= (F20*G01)+(F21*G11)+(F22*G21)+(F23*G31);
float H22= (F20*G02)+(F21*G12)+(F22*G22)+(F23*G32);
float H23= (F20*G03)+(F21*G13)+(F22*G23)+(F23*G33);

float H30= (F30*G00)+(F31*G10)+(F32*G20)+(F33*G30);
float H31= (F30*G01)+(F31*G11)+(F32*G21)+(F33*G31);
float H32= (F30*G02)+(F31*G12)+(F32*G22)+(F33*G32);
float H33= (F30*G03)+(F31*G13)+(F32*G23)+(F33*G33);

float I03= (H00*E[0][3])+(H01*E[1][3])+(H02*E[2][3])+(H03*E[3][3]);
float I13= (H10*E[0][3])+(H11*E[1][3])+(H12*E[2][3])+(H13*E[3][3]);
float I23= (H20*E[0][3])+(H21*E[1][3])+(H22*E[2][3])+(H23*E[3][3]);
float I33= (H30*E[0][3])+(H31*E[1][3])+(H32*E[2][3])+(H33*E[3][3]);
//.................................................................................... 
float X4=I03;
float Y4=I13;
float Z4=I23;

float X3=H03;
float Y3=H13;
float Z3=H23;

float X2=F03;
float Y2=F13;
float Z2=F23;

float X1=0;
float Y1=0;
float Z1=100;

float X0=0;
float Y0=0;
float Z0=0;

   
sendFloat(X0,'a'); 
sendFloat(Y0,'b');
sendFloat(Z0,'c');

sendFloat(X1,'d'); 
sendFloat(Y1,'e');
sendFloat(Z1,'f');

sendFloat(X2,'g'); 
sendFloat(Y2,'h');
sendFloat(Z2,'i');

sendFloat(X3,'j'); 
sendFloat(Y3,'k');
sendFloat(Z3,'l');

sendFloat(X4,'m'); 
sendFloat(Y4,'n');
sendFloat(Z4,'o');
/*

Serial.print  (derajat_A_akhir); 
Serial.print  ("\t");
Serial.print (derajat_B_akhir);
Serial.print ("\t");
Serial.print (derajat_C_akhir);
Serial.print ("\t");
Serial.print (derajat_D_akhir);
Serial.print ("\t");
Serial.println (derajat_E_akhir);
*/
}
