import processing.serial.*;
import peasy.PeasyCam;
pointer digitizer = new pointer(this, 0);
PeasyCam cam;
void settings()
{
 
  size(1200, 700, P3D);

}
void setup(){
  cam = new PeasyCam(this,400);
  
}
void draw()
{
  rotateX(45);
  rotateZ(45);
  scale(1);
  strokeWeight(1);
  background(0);
  stroke(100, 100, 0);
  line(-20, 0, 20, 0);
  line(0, -20, 0, 20);
  stroke (255,255,100);
  fill (200);
  rect (-50,50,100,-100);
  //========================================
  stroke (0,255,0);
  strokeWeight(50);
  line (0,0,0,0,0,100);
  strokeWeight(30);
  line (0,0,100,X2,Y2,Z2);
  strokeWeight(20);
  line (X2,Y2,Z2,X3,Y3,Z3);
  strokeWeight(10);
  line (X3,Y3,Z3,X4,Y4,Z4);
  //========================================
  pushMatrix();
  stroke (0,0,255);
  translate (0,0,Z1);  
  sphere(20);
  popMatrix();
  pushMatrix();
  translate (X2,Y2,Z2);  
  sphere(13);
  popMatrix();
  pushMatrix();
  translate (X3,Y3,Z3);  
  sphere(9);
  popMatrix();
  pushMatrix();
  stroke (255,0,0);
  translate (X4,Y4,Z4);  
  sphere(3);
  popMatrix();
//======================================== 
  cam.beginHUD();
  textSize(50);
  fill(0, 102, 153);
  text("FORWARD KINEMATIC PBG ROBOTIC", 70, 630);
  //text("By Miftahul Arif", 90, 690);
  fill(255); 
  String penX4 = (nf(X4,0,2));
  String penY4 = (nf(Y4,0,2));
  String penZ4 = (nf(Z4,0,2));
  
  String penX3 = (nf(X3,0,2));
  String penY3 = (nf(Y3,0,2));
  String penZ3 = (nf(Z3,0,2));
  
  String penX2 = (nf(X2,0,2));
  String penY2 = (nf(Y2,0,2));
  String penZ2 = (nf(Z2,0,2));
  
  String penX1 = (nf(X1,0,2));
  String penY1 = (nf(Y1,0,2));
  String penZ1 = (nf(Z1,0,2));
  
  String penX0 = (nf(X0,0,2));
  String penY0 = (nf(Y0,0,2));
  String penZ0 = (nf(Z0,0,2));
  
  textSize(30);
  text("X0: "+penX0, 10, 30);
  text("Y0: "+penY0, 10, 60);
  text("Z0: "+penZ0, 10, 90);
  
  text("X1: "+penX1, 10, 130);
  text("Y1: "+penY1, 10, 160);
  text("Z1: "+penZ1, 10, 190);
  
  text("X2: "+penX2, 10, 230);
  text("Y2: "+penY2, 10, 260);
  text("Z2: "+penZ2, 10, 290);
  
  text("X3: "+penX3, 10, 330);
  text("Y3: "+penY3, 10, 360);
  text("Z3: "+penZ3, 10, 390);
  
  text("X4: "+penX4, 10, 430);
  text("Y4: "+penY4, 10, 460);
  text("Z4: "+penZ4, 10, 490);
  cam.endHUD();
 
 
}
